#ifndef _INCLUDE_H_
#define _INCLUDE_H_

#ifndef VAREXT
#define VAREXT extern
#endif

#define UARTEN // 使能串口测试
#define Debug

#include "ATM8F22A4.h"
#include "define.h"
#include "uart0.h"
#include "key.h"
#include "delay.h"
#include "eeprom.h"

#define FLASH_RUN_TYPE_LEN 0x04    // 运行方式FLASH中的数据长度
#define APPLICATION_ADDRESS 0x0500 //  该地址必须为APP开始地址 这里改变需要同步更新 STARTUP.A51  的 APP_ADDRESS  与这里一致
// 该区块默认为BOOTLOADER区块的最后一个区块,程序中最后一个区块一定不能被程序覆盖
#define USER_FLASH_DATA_PAGE_ADDRESS (APPLICATION_ADDRESS - 0x10) // 0X0A00

#define Syscon_HRC_32M 0xF5 // 32M内部时钟，HRC,LRC使能，禁止外部晶振
#define Syscon_HRC_16M 0xB5 // 16M内部时钟，HRC,LRC使能，禁止外部晶振
#define Syscon_HRC_8M 0x75  // 8M内部时钟，HRC,LRC使能，禁止外部晶振
#define BOR_4_3V 0xF7
#define BOR_3_7V 0xF5

VAREXT uint8 guc_TimeEvent;
#define flgEtTim_2ms 0x01
#define flgEtTim_250ms 0x02
#define flgEtTim_Second 0x04
#define flgEtTim_Minute 0x08

VAREXT uint8 guc_2mscnt;
VAREXT uint8 guc_250mscnt;
VAREXT uint16 guc_secscnt;

VAREXT uint8 guc_KeyEvent;
#define flgEtKey_Set 0x01
#define flgEtKey_LongKey 0x02

VAREXT uint8 guc_ComEvent;
#define flgCom_Complete 0x01

VAREXT uint8 guc_IapCommand;

#define CLRWDT()       \
    {                  \
        WDTRLD = 0x5A; \
        WDTRLD = 0x3C; \
        WDTRLD = 0x5A; \
        WDTRLD = 0x3C; \
    }

#define Disable_KeyPorIn() \
    {                      \
        P1CR &= ~BIT1;     \
        P1PCR &= ~BIT1;    \
    }
#define KeyPortIn()    \
    {                  \
        P1CR &= ~BIT1; \
        P1PCR |= BIT1; \
    }
#define KeySt() (!(P1 & BIT1))

#define TEST_IOOUT()    \
    {                   \
        P0CR |= BIT2;   \
        P0ODR &= ~BIT2; \
    }
#define TEST_IOFALSH()                            \
    {                                             \
        P0_2 ^= 1; /*P0CR |= BIT2;P0ODR&=~BIT2;*/ \
    }

#define IE_UART0_enable IEN0 |= 0x10

#endif
