#ifndef __UART_H__
#define __UART_H__

#ifndef COMBOTTOMEXT
#define COMBOTTOMEXT extern
#else
#define COMBOTTOMSELT
#endif

#define UART0 0
#define UART1 1

#define UART UART0

#if (UART == UART0)

#define SBUF_USER S0BUF
#define SCON_USER S0CON

#else

#define SBUF_USER S1BUF
#define SCON_USER S1CON

#endif

#ifdef UARTEN

#define Uart_RevEn()
#define Uart_SendEn()

#define Const_DyUart1Over 0x64 // 模拟口的溢出保护，在10ms中执行，等于0xff则初始化
#define Ret_OK 0x00            // 正确
#define Ret_Err 0xff           // 错误

#define Const_MaxComNum 1 // 以下为对应的buf序号，如果三个共用一个buf，则全部为0，如果分开，则根据实际分开
#define ComIndex_Uart2 1  //
#define ComIndex_Uart1 0  //
#define ComIndex_Uart4 2  //
// 端口
#define Const_MaxPortNum 1 // 总的端口数
#define Port_Uart2 1       // 端口与COM的对应关系
#define Port_Uart1 0       //
#define Port_Uart4 2       //
#define Port_Idle 0xff     // 该COM目前没有使用，可以允许数据写入到该COM对应的buf中

// 超时时间
#define Const_DyUartOut 0xff // 超时保护
#define Const_DyRvPack 5     // 500ms,接收超时时间，溢出表示一个数据包接结束标志

// COM口的状态
#define ComStt_Recv 01     // COM处于接收状态，在中断中处理
#define ComStt_Send 02     // COM处于发送状态，在中断中处理
#define ComStt_Idle 03     // COM处于空闲状态
#define ComStt_WaitProc 04 // COM处于等待处于状态，在主程序中处理

// 与串口BUFF相关
#define Const_MaxBufLen 20 // 缓冲区容量

// 变量
typedef struct s_com
{
    uint8 ucPort;
    uint8 ucStt;                  // 通讯状态ComStt_Recv/ComStt_Send/COM_IDLE
    uint8 ucRecvTmr;              // 单位10ms,相当于调用周期为10ms
    uint8 ucOverTmr;              // 单位10ms,相当于调用周期为10ms,保护用
                                  //  uint8    ucFrmHeadCnt;                                           // 帧头处理
    uint8 ucLen;                  // 收发的数据总长度
    uint8 ucPos;                  // 当前处理数据的位置,相当于指向ucBuf的一个指针
    uint8 ucBuf[Const_MaxBufLen]; // 通讯收发数据缓冲区
} S_COM;

COMBOTTOMEXT S_COM idata gs_ComGroup[Const_MaxComNum]; // 通讯用的缓存
COMBOTTOMEXT uint8 idata guc_comdelay;                 // 通讯显示延时

// 函数
COMBOTTOMEXT void ComBom_Init(uint8 ucNo);
COMBOTTOMEXT void ComBom_InitAll(void);
COMBOTTOMEXT void ComBom_StartSend(uint8 ucNo);
COMBOTTOMEXT void ComBom_10msDy(void);
COMBOTTOMEXT void Init_Uart();
COMBOTTOMEXT void Uart_Dy10ms(void);
COMBOTTOMEXT void Uart_Receive(void);
COMBOTTOMEXT void Uart_Transmit(void);
COMBOTTOMEXT void ComApp_Proc(void);

#endif

#endif