#define KEYEXT
#include "Include.h"
/*=========================================================================================\n
* @描述: 按键初始化
===========================================================================================*/
void KeyInit(void)
{
    uint8 i;
    KeyPortIn();
    for (i = 0; i < KeyNums; i++)
    {
        gs_KeyCtr[i].KeyThd = 10;
        gs_KeyCtr[i].LgKeyThd = 900;
    }
    guc_KeyEvent = 0;
}

void LongKeyProc(uint8 keyNum)
{
    if (keyNum == SetKey)
    {
        guc_KeyEvent = flgEtKey_LongKey;
    }
}
/*=========================================================================================\n
* @描述: 按键处理函数
===========================================================================================*/
void KeyProc(void)
{
    if (guc_KeyEvent & flgEtKey_Set)
    {
        if (gs_KeyCtr[SetKey].Status == KeyRls) // 按键为释放
        {
            guc_KeyEvent &= ~flgEtKey_Set; // 清除标志
        }
    }
    else if (guc_KeyEvent & flgEtKey_LongKey)
    {
        guc_KeyEvent &= ~flgEtKey_LongKey; // 清除标志
    }
    else                    //
    {                       //
        guc_KeyEvent = 0x0; //  防止其他位设置起来，频繁进入该事件
    }
}
/*=========================================================================================\n
* @描述: 按键扫描
===========================================================================================*/
void KeyScan(void)
{

    if (KeySt()) // 上翻键延时开启
    {
        if ((gs_KeyCtr[SetKey].DlyCnt >= gs_KeyCtr[SetKey].KeyThd) &&
            gs_KeyCtr[SetKey].Status == KeyRls)
        {

            guc_KeyEvent |= flgEtKey_Set;     // 置上翻键标记
            gs_KeyCtr[SetKey].Status = KeyDw; // 上翻键为按下状态
        }
        if (gs_KeyCtr[SetKey].Status != KeyDWLong)
        {
            gs_KeyCtr[SetKey].DlyCnt++; // 延时计数器加1
        }

        if ((gs_KeyCtr[SetKey].DlyCnt >= gs_KeyCtr[SetKey].LgKeyThd) &&
            (gs_KeyCtr[SetKey].Status == KeyDw))
        {                                         // 如果键状态为按下，并且延时计数大于2s为长按
            gs_KeyCtr[SetKey].Status = KeyDWLong; // 按键状态为长按
            LongKeyProc(SetKey);                  // 长按键处理
        }
    }
    else
    {
        gs_KeyCtr[SetKey].DlyCnt = 0;      // 延时计数清零
        gs_KeyCtr[SetKey].Status = KeyRls; // 按键为释放
    }
}
